from socket import socket, AF_INET, SOCK_DGRAM,SOL_SOCKET,SO_REUSEADDR
from threading import Thread
import UDPp2p.UDPReceiverHandler


class UDPDefaultHandler(UDPp2p.UDPReceiverHandler.UDPReceiverHandler):

    def Handle(self, message):
        pass


class UDPReceiverThread(Thread):

    def __init__(self, port=5554, buffer=1024, handler=UDPDefaultHandler()):
        super(UDPReceiverThread, self).__init__()
        self.stopped = False
        self.port = port
        self.buffer = buffer
        self.sock = socket(AF_INET, SOCK_DGRAM)
        self.sock.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        self.sock.bind(('', self.port))
        self.udphandlers = {handler}

    def run(self):
        while not self.stopped:
            data = self.sock.recv(self.buffer)  # buffer size is 1024 bytes
            for handler in self.udphandlers:
                print("handling")
                handler.Handle(data)

        self.sock.close()

    def setport(self, port):
        self.port=port

    def setbuffer(self, buffer):
        self.buffer = buffer

    def stop(self):
        self.stopped = True
        self.sock.close()

    def addlistener(self, handler):
        self.udphandlers.add(handler)

