from socket import socket, AF_INET, SOCK_DGRAM, SOL_SOCKET, SO_REUSEADDR, SO_BROADCAST
import UDPp2p.UDPp2pUtilities


class UDPTransmitter:

    def __init__(self,  ip=UDPp2p.UDPp2pUtilities.getlocalip(), port=5554):
        self.socket = socket(AF_INET, SOCK_DGRAM);
        self.ip = ip
        self.port = port

    def sendMessage(self, message, ip, port):
        sock = socket(AF_INET, SOCK_DGRAM)
        sock.sendto(str.encode(message), (ip, port))

    def setip(self, ip):
        self.ip=ip

    def setport(self, port):
        self.port=port

    def sendMessageContinued(self, message):
        sock=socket(AF_INET, SOCK_DGRAM)
        sock.sendto(str.encode(message),(self.ip, self.port))

    def sendBroadcastMessage(self, message):
        sock = socket(AF_INET, SOCK_DGRAM)  # UDP
        sock.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        sock.setsockopt(SOL_SOCKET, SO_BROADCAST, 1)
        sock.sendto(str.encode(message), ("255.255.255.255", self.port))

    def closeContinued(self):
        self.socket.close()

